Unit AFP5C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP5C(var A :Array of Complex; N :Integer; M :Integer;
                var D1 :Array of Complex; var D2 :Array of Complex);

implementation

procedure AFP5C(var A :Array of Complex; N :Integer; M :Integer;
                var D1 :Array of Complex; var D2 :Array of Complex);
var
I,J,B,C,D :Integer;
E,F,H,Q,R,BE,BG :Real;
G,K,BF,BH :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39;
begin
for B:=1 to N do
 begin
  if ( B <> M ) 
   then goto _1;
  D1[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := Cmplx(0.0,0.0);
  goto _39;
_1:
  for J:=B to M do
   begin
    D1[J-1] := A[(B-1)+(J-1)*N];
_2:
   end;
  E := 0.0;
  D := 1;
  for J:=B to M do
   begin
    K := D1[J-1];
_3:
    Q := Creal(K);
    R := Aimag(K);
    Q := Abs(Q);
    R := Abs(R);
    if ( Q-R ) < 0
     then goto _5
     else if ( Q-R ) > 0
           then goto _4
           else goto _4;
_4:
    F := Q;
    goto _6;
_5:
    F := R;
_6:
    if ( F = 0.0 ) 
     then goto _7;
    Q := Q/F;
    R := R/F;
    Q := Q*Q+R*R;
    F := F*Sqrt(Q);
_7:
    case D of
     1: goto _8;
     2: goto _13;
     3: goto _25;
     4: goto _30;
    end;
_8:
    if ( E >= F ) 
     then goto _9;
    E := F;
_9:
   end;
  if ( E <> 0.0 ) 
   then goto _10;
  C := B+1;
  goto _22;
_10:
  H := 0.0;
  for J:=B to M do
   begin
    F := 0.0;
    BE := Creal(D1[J-1])/E;
    F := F+BE*BE;
    BE := Aimag(D1[J-1])/E;
    F := F+BE*BE;
    H := H+F;
_11:
   end;
  E := Sqrt(H)*E;
  F := 1.0/E;
  for J:=B to M do
   begin
    D1[J-1] := MulC(D1[J-1],Cmplx(F,0.0));
_12:
   end;
  D := 2;
  K := D1[B-1];
  goto _3;
_13:
  if ( F <> 0.0 ) 
   then goto _14;
  D1[B-1] := Cmplx(1.0,0.0);
  G := Cmplx(-E,0.0);
  goto _16;
_14:
  G := DivC(D1[B-1],Cmplx(F,0.0));
  D1[B-1] := AddC(D1[B-1],G);
  F := 1.0/Sqrt(1.0+F);
  for J:=B to M do
   begin
    D1[J-1] := MulC(D1[J-1],Cmplx(F,0.0));
_15:
   end;
  G := MulC(SubC(Cmplx(0.0,0.0),Cmplx(E,0.0)),G);
_16:
  for J:=B to M do
   begin
    A[(B-1)+(J-1)*N] := D1[J-1];
_17:
   end;
  if ( B <> N ) 
   then goto _18;
  D1[B-1] := G;
  goto _39;
_18:
  C := B+1;
  for I:=C to N do
   begin
    BF := Cmplx(0.0,0.0);
    for J:=B to M do
     begin
      BF := AddC(BF,MulC(A[(I-1)+(J-1)*N],Conjg(D1[J-1])));
_19:
     end;
    for J:=B to M do
     begin
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(BF,D1[J-1]));
_20:
     end;
_21:
   end;
  D1[B-1] := G;
_22:
  if ( C <> N ) 
   then goto _23;
  D2[B-1] := A[(C-1)+(B-1)*N];
  A[(C-1)+(B-1)*N] := Cmplx(0.0,0.0);
  goto _38;
_23:
  for I:=C to N do
   begin
    D2[I-1] := A[(I-1)+(B-1)*N];
_24:
   end;
  E := 0.0;
  D := 3;
  for I:=C to N do
   begin
    K := D2[I-1];
    goto _3;
_25:
    if ( E >= F ) 
     then goto _26;
    E := F;
_26:
   end;
  if ( E <> 0.0 ) 
   then goto _27;
  D2[B-1] := Cmplx(0.0,0.0);
  goto _38;
_27:
  H := 0.0;
  for I:=C to N do
   begin
    F := 0.0;
    BG := Creal(D2[I-1])/E;
    F := F+BG*BG;
    BG := Aimag(D2[I-1])/E;
    F := F+BG*BG;
    H := H+F;
_28:
   end;
  E := Sqrt(H)*E;
  F := 1.0/E;
  for I:=C to N do
   begin
    D2[I-1] := MulC(D2[I-1],Cmplx(F,0.0));
_29:
   end;
  D := 4;
  K := D2[C-1];
  goto _3;
_30:
  if ( F <> 0.0 ) 
   then goto _31;
  D2[C-1] := Cmplx(1.0,0.0);
  G := Cmplx(-E,0.0);
  goto _33;
_31:
  G := DivC(D2[C-1],Cmplx(F,0.0));
  D2[C-1] := AddC(D2[C-1],G);
  F := 1.0/Sqrt(1.0+F);
  for I:=C to N do
   begin
    D2[I-1] := MulC(D2[I-1],Cmplx(F,0.0));
_32:
   end;
  G := MulC(SubC(Cmplx(0.0,0.0),Cmplx(E,0.0)),G);
_33:
  for I:=C to N do
   begin
    A[(I-1)+(B-1)*N] := D2[I-1];
_34:
   end;
  for J:=C to M do
   begin
    BH := Cmplx(0.0,0.0);
    for I:=C to N do
     begin
      BH := AddC(BH,MulC(A[(I-1)+(J-1)*N],Conjg(D2[I-1])));
_35:
     end;
    for I:=C to N do
     begin
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(BH,D2[I-1]));
_36:
     end;
_37:
   end;
  D2[B-1] := G;
_38:
 end;
_39:
end;

end.
